diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/config.cc ns-3.36/src/core/model/config.cc
--- ns-3.35/src/core/model/config.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/config.cc	2022-04-30 18:23:57.794733300 -0700
@@ -619,29 +619,29 @@
 public:
   // Keep Set and SetFailSafe since their errors are triggered
   // by the underlying ObjecBase functions.
-  /** \copydoc Config::Set() */
+  /** \copydoc ns3::Config::Set() */
   void Set (std::string path, const AttributeValue &value);
-  /** \copydoc Config::SetFailSafe() */
+  /** \copydoc ns3::Config::SetFailSafe() */
   bool SetFailSafe (std::string path, const AttributeValue &value);
-  /** \copydoc Config::ConnectWithoutContextFailSafe() */
+  /** \copydoc ns3::Config::ConnectWithoutContextFailSafe() */
   bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb);
-  /** \copydoc Config::ConnectFailSafe() */
+  /** \copydoc ns3::Config::ConnectFailSafe() */
   bool ConnectFailSafe (std::string path, const CallbackBase &cb);
-  /** \copydoc Config::DisconnectWithoutContext() */
+  /** \copydoc ns3::Config::DisconnectWithoutContext() */
   void DisconnectWithoutContext (std::string path, const CallbackBase &cb);
-  /** \copydoc Config::Disconnect() */
+  /** \copydoc ns3::Config::Disconnect() */
   void Disconnect (std::string path, const CallbackBase &cb);
-  /** \copydoc Config::LookupMatches() */
+  /** \copydoc ns3::Config::LookupMatches() */
   MatchContainer LookupMatches (std::string path);
 
-  /** \copydoc Config::RegisterRootNamespaceObject() */
+  /** \copydoc ns3::Config::RegisterRootNamespaceObject() */
   void RegisterRootNamespaceObject (Ptr<Object> obj);
-  /** \copydoc Config::UnregisterRootNamespaceObject() */
+  /** \copydoc ns3::Config::UnregisterRootNamespaceObject() */
   void UnregisterRootNamespaceObject (Ptr<Object> obj);
 
-  /** \copydoc Config::GetRootNamespaceObjectN() */
+  /** \copydoc ns3::Config::GetRootNamespaceObjectN() */
   std::size_t GetRootNamespaceObjectN (void) const;
-  /** \copydoc Config::GetRootNamespaceObject() */
+  /** \copydoc ns3::Config::GetRootNamespaceObject() */
   Ptr<Object> GetRootNamespaceObject (std::size_t i) const;
 
 private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/config.h ns-3.36/src/core/model/config.h
--- ns-3.35/src/core/model/config.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/config.h	2022-04-30 18:23:57.794733300 -0700
@@ -67,6 +67,10 @@
  */
 void Set (std::string path, const AttributeValue &value);
 /**
+ * \ingroup config
+ * \param [in] path A path to match attributes.
+ * \param [in] value The value to set in all matching attributes.
+ *
  * This function will attempt to find attributes which
  * match the input path and will then set their value to the input
  * value, and will return true if at least one such attribute is found.
@@ -123,6 +127,10 @@
  */
 void ConnectWithoutContext (std::string path, const CallbackBase &cb);
 /**
+ * \ingroup config
+ * \param [in] path A path to match trace sources.
+ * \param [in] cb The callback to connect to the matching trace sources.
+ *
  * This function will attempt to find all trace sources which
  * match the input path and will then connect the input callback
  * to them.  If no matching trace sources are found, this method will 
@@ -153,6 +161,10 @@
  */
 void Connect (std::string path, const CallbackBase &cb);
 /**
+ * \ingroup config
+ * \param [in] path A path to match trace sources.
+ * \param [in] cb The callback to connect to the matching trace sources.
+ *
  * This function will attempt to find all trace sources which
  * match the input path and will then connect the input callback
  * to them in such a way that the callback will receive an extra
@@ -196,16 +208,25 @@
 
   /**
    * \returns An iterator which points to the first item in the container
+   * @{
    */
   MatchContainer::Iterator Begin (void) const;
+  MatchContainer::Iterator begin (void) const { return Begin (); }
+  /** @} */
   /**
    * \returns An iterator which points to the last item in the container
+   * @{
    */
   MatchContainer::Iterator End (void) const;
+  MatchContainer::Iterator end (void) const { return End (); }
+  /** @} */
   /**
    * \returns The number of items in the container
+   * @{
    */
   std::size_t GetN (void) const;
+  std::size_t size (void) const { return GetN (); }
+  /** @} */
   /**
    * \param [in] i Index of item to lookup ([0,n[)
    * \returns The item requested.
@@ -236,6 +257,9 @@
    */
   void Set (std::string name, const AttributeValue &value);
   /**
+   * \param [in] name Name of attribute to set
+   * \param [in] value Value to set to the attribute
+   *
    * Set the specified attribute value to all the objects stored in this
    * container.  This method will return true if any attributes could be
    * set, and false otherwise.
@@ -254,6 +278,9 @@
    */
   void Connect (std::string name, const CallbackBase &cb);
   /**
+   * \param [in] name The name of the trace source to connect to
+   * \param [in] cb The sink to connect to the trace source
+   *
    * Connect the specified sink to all the objects stored in this
    * container.  This method will return true if any trace sources could be
    * connected, and false otherwise.
@@ -272,6 +299,9 @@
    */
   void ConnectWithoutContext (std::string name, const CallbackBase &cb);
   /**
+   * \param [in] name The name of the trace source to connect to
+   * \param [in] cb The sink to connect to the trace source
+   *
    * Connect the specified sink to all the objects stored in this
    * container.  This method will return true if any trace sources could be
    * connected, and false otherwise.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/default-simulator-impl.cc ns-3.36/src/core/model/default-simulator-impl.cc
--- ns-3.35/src/core/model/default-simulator-impl.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/default-simulator-impl.cc	2022-04-30 18:23:57.794733300 -0700
@@ -20,11 +20,8 @@
 
 #include "simulator.h"
 #include "default-simulator-impl.h"
-#include "scheduler.h"
-#include "event-impl.h"
 
-#include "ptr.h"
-#include "pointer.h"
+#include "scheduler.h"
 #include "assert.h"
 #include "log.h"
 
@@ -61,13 +58,8 @@
 {
   NS_LOG_FUNCTION (this);
   m_stop = false;
-  // uids are allocated from 4.
-  // uid 0 is "invalid" events
-  // uid 1 is "now" events
-  // uid 2 is "destroy" events
-  m_uid = 4;
-  // before ::Run is entered, the m_currentUid will be zero
-  m_currentUid = 0;
+  m_uid = EventId::UID::VALID;
+  m_currentUid = EventId::UID::INVALID;
   m_currentTs = 0;
   m_currentContext = Simulator::NO_CONTEXT;
   m_unscheduledEvents = 0;
@@ -140,6 +132,9 @@
 {
   Scheduler::Event next = m_events->RemoveNext ();
 
+  PreEventHook (EventId (next.impl, next.key.m_ts, 
+                         next.key.m_context, next.key.m_uid));
+
   NS_ASSERT (next.key.m_ts >= m_currentTs);
   m_unscheduledEvents--;
   m_eventCount++;
@@ -283,15 +278,7 @@
 {
   NS_ASSERT_MSG (SystemThread::Equals (m_main), "Simulator::ScheduleNow Thread-unsafe invocation!");
 
-  Scheduler::Event ev;
-  ev.impl = event;
-  ev.key.m_ts = m_currentTs;
-  ev.key.m_context = GetContext ();
-  ev.key.m_uid = m_uid;
-  m_uid++;
-  m_unscheduledEvents++;
-  m_events->Insert (ev);
-  return EventId (event, ev.key.m_ts, ev.key.m_context, ev.key.m_uid);
+  return Schedule (Time (0), event);
 }
 
 EventId
@@ -328,7 +315,7 @@
 void
 DefaultSimulatorImpl::Remove (const EventId &id)
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       // destroy events.
       for (DestroyEvents::iterator i = m_destroyEvents.begin (); i != m_destroyEvents.end (); i++)
@@ -370,7 +357,7 @@
 bool
 DefaultSimulatorImpl::IsExpired (const EventId &id) const
 {
-  if (id.GetUid () == 2)
+  if (id.GetUid () == EventId::UID::DESTROY)
     {
       if (id.PeekEventImpl () == 0
           || id.PeekEventImpl ()->IsCancelled ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/default-simulator-impl.h ns-3.36/src/core/model/default-simulator-impl.h
--- ns-3.35/src/core/model/default-simulator-impl.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/default-simulator-impl.h	2022-04-30 18:23:57.794733300 -0700
@@ -22,13 +22,9 @@
 #define DEFAULT_SIMULATOR_IMPL_H
 
 #include "simulator-impl.h"
-#include "scheduler.h"
-#include "event-impl.h"
 #include "system-thread.h"
 #include "system-mutex.h"
 
-#include "ptr.h"
-
 #include <list>
 
 /**
@@ -39,6 +35,9 @@
 
 namespace ns3 {
 
+// Forward
+class Scheduler;
+
 /**
  * \ingroup simulator
  *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/deprecated.h ns-3.36/src/core/model/deprecated.h
--- ns-3.35/src/core/model/deprecated.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/deprecated.h	2022-04-30 18:23:57.794733300 -0700
@@ -40,44 +40,51 @@
  * For example,
  * \snippet src/core/doc/deprecated-example.h doxygen snippet
  *
- * To ease future maintenance please use the versioned forms:
- * `NS_DEPRECATED_3_XX`, not the generic `NS_DEPRECATED`
+ * Please follow these two guidelines to ease future maintenance
+ * (primarily the eventual removal of the deprecated code):
+ *
+ * 1.  Please use the versioned form `NS_DEPRECATED_3_XX`, 
+ *     not the generic `NS_DEPRECATED`.
+ *
+ * 2.  Typically only the declaration needs to be deprecated, 
+ *
+ *     \code
+ *     NS_DEPRECATED_3_XX ("see TheNewWay") void SomethingUseful ();
+ *     \endcode
+ *
+ *     but it's helpful to put the same macro as a comment 
+ *     at the site of the definition, to make it easier to find
+ *     all the bits which eventually have to be removed:
+ *
+ *     \code
+ *     \/\* NS_DEPRECATED_3_XX ("see TheNewWay") *\\/
+ *     void SomethingUseful () { ... }
+ *     \endcode.
+ *
+ * \param msg Optional message to add to the compiler warning.
+ *
  */
-#if defined(__GNUC__)
-/* Test for GCC >= 4.1 */
-#define GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100)
-#if (GCC_VERSION >= 40100)
-#define NS_DEPRECATED  __attribute__ ((deprecated))
-#endif
-#undef GCC_VERSION
+#define NS_DEPRECATED(msg) [[deprecated (msg)]]
 
-
-#elif defined(__clang__) || defined(__llvm__)
-#define NS_DEPRECATED  __attribute__ ((deprecated))
-
-#elif defined(_MSC_VER)
-#define NS_DEPRECATED __declspec(deprecated)
-
-#else
-#define NS_DEPRECATED
-#endif
+/**
+ * \ingroup core
+ * \def NS_DEPRECATED_3_36
+ * Tag for things deprecated in version ns-3.36.
+ */
+#define NS_DEPRECATED_3_36(msg) NS_DEPRECATED(msg)
 
 /**
  * \ingroup core
  * \def NS_DEPRECATED_3_35
  * Tag for things deprecated in version ns-3.35.
  */
-#ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_35 NS_DEPRECATED
-#endif
+#define NS_DEPRECATED_3_35 NS_DEPRECATED("")
 
 /**
  * \ingroup core
  * \def NS_DEPRECATED_3_34
  * Tag for things deprecated in version ns-3.34.
  */
-#ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_34 NS_DEPRECATED
-#endif
+#define NS_DEPRECATED_3_34 NS_DEPRECATED("")
 
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/des-metrics.h ns-3.36/src/core/model/des-metrics.h
--- ns-3.35/src/core/model/des-metrics.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/des-metrics.h	2022-04-30 18:23:57.794733300 -0700
@@ -88,14 +88,14 @@
  *
  * Enable DES Metrics at configure time with
  * \verbatim
-   $ waf configure ... --enable-des-metrics \endverbatim
+   $ ns3 configure ... --enable-des-metrics \endverbatim
  *
  * <b> Working with DES Metrics </b>
  *
  * Some useful shell pipelines:
  *
  * \li Run everything, retaining the results directory: <br/>
- *   \code  ./test.py --nowaf --retain \endcode
+ *   \code  ./test.py --nobuild --retain \endcode
  * \li Example traces end up in \c testpy-output/, so move there: <br/>
  *   \code cd testpy-output/$(date +"%F")*_/  \endcode
  *   (Remove the `_', which is to work around a Doxygen limitation.)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/enum.cc ns-3.36/src/core/model/enum.cc
--- ns-3.35/src/core/model/enum.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/enum.cc	2022-04-30 18:23:57.794733300 -0700
@@ -138,7 +138,7 @@
   auto pvalue = p->Get ();
   auto it = std::find_if (m_valueSet.begin (), m_valueSet.end (),
                           [pvalue] (Value v) { return v.first == pvalue; } );
-  return (it != m_valueSet.end ()) ? true : false;
+  return (it != m_valueSet.end ());
 }
 std::string
 EnumChecker::GetValueTypeName (void) const
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/enum.h ns-3.36/src/core/model/enum.h
--- ns-3.35/src/core/model/enum.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/enum.h	2022-04-30 18:23:57.794733300 -0700
@@ -155,6 +155,7 @@
  * \returns The AttributeChecker
  * \param [in] v  The default enum value.
  * \param [in] n  The corresponding name.
+ * \param [in] args Any additional arguments.
  */
 template <typename... Ts>
 Ptr<const AttributeChecker>
@@ -174,6 +175,7 @@
  * \param [in] checker The AttributeChecker.
  * \param [in] v  The next enum value.
  * \param [in] n  The corresponding name.
+ * \param [in] args Any additional arguments.
  */
 
 template <typename... Ts>
@@ -187,7 +189,7 @@
 /**
  * Terminate the recursion of variadic arguments.
  *
- * \returns The \pname checker
+ * \returns The \p checker
  * \param [in] checker The AttributeChecker.
  */
 // inline to allow tail call optimization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/event-id.h ns-3.36/src/core/model/event-id.h
--- ns-3.35/src/core/model/event-id.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/event-id.h	2022-04-30 18:23:57.794733300 -0700
@@ -53,6 +53,22 @@
 class EventId
 {
 public:
+
+  /** Special values of the event UID. */
+  enum UID 
+    {
+      /** Invalid UID value. */
+      INVALID = 0,
+      /** ScheduleNow() events. */
+      NOW = 1,
+      /** ScheduleDestroy() events. */
+      DESTROY = 2,
+      /** Reserved UID. */
+      RESERVED = 3,
+      /** Schedule(), etc. events. */
+      VALID = 4
+    };
+
   /** Default constructor. This EventId does nothing. */
   EventId ();
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/example-as-test.cc ns-3.36/src/core/model/example-as-test.cc
--- ns-3.35/src/core/model/example-as-test.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/example-as-test.cc	2022-04-30 18:23:57.794733300 -0700
@@ -21,12 +21,12 @@
 #include "example-as-test.h"
 #include "ascii-test.h"
 #include "log.h"
-#include "unused.h"
 #include "assert.h"
 
 #include <string>
 #include <sstream>
-#include <cstdlib>  // itoa(), system ()
+#include <cstdlib>  // itoa(), system (), getenv ()
+#include <cstring>
 
 /**
  * \file
@@ -88,8 +88,8 @@
   std::stringstream ss;
 
   // Use bash as shell to allow use of PIPESTATUS
-  ss << "bash -c './waf --run-no-build " << m_program
-     << " --command-template=\"" << GetCommandTemplate () << "\""
+  ss << "bash -c './ns3 run " << m_program
+     << " --no-build --command-template=\"" << GetCommandTemplate () << "\""
 
     // redirect std::clog, std::cerr to std::cout
      << " 2>&1 "
@@ -100,7 +100,7 @@
      << GetPostProcessingCommand ()
      << " > " << testFile
 
-    // Get the status of waf
+    // Get the status of ns3
      << "; exit ${PIPESTATUS[0]}'";
 
   int status = std::system (ss.str ().c_str ());
@@ -123,6 +123,13 @@
   // Make sure the example didn't outright crash
   NS_TEST_ASSERT_MSG_EQ (status, 0, "example " + m_program + " failed");
 
+  // Check that we're not just introspecting the command-line
+  const char * envVar = std::getenv ("NS_COMMANDLINE_INTROSPECTION");
+  if (envVar != 0 && std::strlen (envVar) != 0)
+    {
+      return;
+    }
+
   // Compare the testFile to the reference file
   NS_ASCII_TEST_EXPECT_EQ (testFile, refFile);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/example-as-test.h ns-3.36/src/core/model/example-as-test.h
--- ns-3.35/src/core/model/example-as-test.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/example-as-test.h	2022-04-30 18:23:57.794733300 -0700
@@ -78,7 +78,7 @@
    * Customization point for more complicated patterns
    * to invoke the example program.
    *
-   * \returns The string to be given to the `waf --command-template=` argument.
+   * \returns The string to be given to the `ns3 --command-template=` argument.
    */
   virtual std::string GetCommandTemplate (void) const;
 
@@ -126,7 +126,7 @@
  * \par Test Addition
  *
  * To use an example program as a test you need to create a test suite
- * file and add it to the appropriate list in your module wscript
+ * file and add it to the appropriate list in your module CMakeLists.txt
  * file. The "good" output reference file needs to be generated for
  * detecting regressions.
  *
@@ -148,7 +148,7 @@
  * the same example is run twice with different arguments.
  *
  * You then need to add that newly created test suite file to the list
- * of test sources in `mymodule/wscript`.   Building of examples
+ * of test sources in `mymodule/CMakeLists.txt`.   Building of examples
  * is an option so you need to guard the inclusion of the test suite:
  *
  * \code{.py}
@@ -156,7 +156,7 @@
  *    module.source.append('model/mymodule-examples-test-suite.cc')
  * \endcode
  *
- * Since you modified a wscript file you need to reconfigure and
+ * Since you modified a CMakeLists.txt file you need to reconfigure and
  * rebuild everything.
  *
  * You just added new tests so you will need to generate the "good"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/global-value.h ns-3.36/src/core/model/global-value.h
--- ns-3.35/src/core/model/global-value.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/global-value.h	2022-04-30 18:23:57.794733300 -0700
@@ -108,7 +108,6 @@
    * Get the value.
    * \param [out] value The AttributeValue to set to the value
    *                    of this GlobalValue
-   * \returns The current value of this GlobalValue.
    */
   void GetValue (AttributeValue &value) const;
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/hash.cc ns-3.36/src/core/model/hash.cc
--- ns-3.35/src/core/model/hash.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/hash.cc	2022-04-30 18:23:57.794733300 -0700
@@ -32,6 +32,13 @@
 
 NS_LOG_COMPONENT_DEFINE ("Hash");
 
+Hasher& GetStaticHash (void)
+{
+  static Hasher g_hasher = Hasher ();
+  g_hasher.clear();
+  return g_hasher;
+}
+
 Hasher::Hasher ()
 {
   m_impl = Create <Hash::Function::Murmur3> ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/hash.h ns-3.36/src/core/model/hash.h
--- ns-3.35/src/core/model/hash.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/hash.h	2022-04-30 18:23:57.794733300 -0700
@@ -271,32 +271,38 @@
   Global hash functions, inlined for rvo
 */
 
+/**
+  * \brief Get a reference to the static global hasher at g_hasher
+  * \return Reference to the static Hasher instance.
+  */
+Hasher& GetStaticHash (void);
+
 inline
 uint32_t
 Hash32 (const char * buffer, const std::size_t size)
 {
-  return Hasher ().GetHash32 (buffer, size);
+  return GetStaticHash ().GetHash32 (buffer, size);
 }
 
 inline
 uint64_t
 Hash64 (const char * buffer, const std::size_t size)
 {
-  return Hasher ().GetHash64 (buffer, size);
+  return GetStaticHash ().GetHash64 (buffer, size);
 }
 
 inline
 uint32_t
 Hash32 (const std::string s)
 {
-  return Hasher ().GetHash32 (s);
+  return GetStaticHash ().GetHash32 (s);
 }
 
 inline
 uint64_t
 Hash64 (const std::string s)
 {
-  return Hasher ().GetHash64 (s);
+  return GetStaticHash ().GetHash64 (s);
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/heap-scheduler.cc ns-3.36/src/core/model/heap-scheduler.cc
--- ns-3.35/src/core/model/heap-scheduler.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/heap-scheduler.cc	2022-04-30 18:23:57.794733300 -0700
@@ -99,7 +99,7 @@
 HeapScheduler::IsRoot (std::size_t id) const
 {
   NS_LOG_FUNCTION (this << id);
-  return (id == Root ()) ? true : false;
+  return (id == Root ());
 }
 
 std::size_t
@@ -114,7 +114,7 @@
 HeapScheduler::IsBottom (std::size_t id) const
 {
   NS_LOG_FUNCTION (this << id);
-  return (id >= m_heap.size ()) ? true : false;
+  return (id >= m_heap.size ());
 }
 
 void
@@ -146,7 +146,7 @@
 HeapScheduler::IsEmpty (void) const
 {
   NS_LOG_FUNCTION (this);
-  return (m_heap.size () == 1) ? true : false;
+  return (m_heap.size () == 1);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/int64x64-128.cc ns-3.36/src/core/model/int64x64-128.cc
--- ns-3.35/src/core/model/int64x64-128.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/int64x64-128.cc	2022-04-30 18:23:57.794733300 -0700
@@ -57,7 +57,7 @@
   bool negB = sb < 0;
   ua = negA ? -sa : sa;
   ub = negB ? -sb : sb;
-  return (negA && !negB) || (!negA && negB);
+  return negA != negB;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/core/model/int64x64-128.h ns-3.36/src/core/model/int64x64-128.h
--- ns-3.35/src/core/model/int64x64-128.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/core/model/int64x64-128.h	2022-04-30 18:23:57.794733300 -0700
@@ -20,14 +20,24 @@
 #include "ns3/core-config.h"
 
 #if !defined(INT64X64_128_H) && defined (INT64X64_USE_128) && !defined(PYTHON_SCAN)
+/**
+ * \ingroup highprec
+ * Use uint128_t for int64x64_t implementation
+ */
 #define INT64X64_128_H
 
 #include <stdint.h>
 #include <cmath>  // pow
 
 #if defined(HAVE___UINT128_T) && !defined(HAVE_UINT128_T)
+/**
+ * \ingroup highprec
+ * Some compilers do not have this defined, so we define it.
+ * @{
+ */
 typedef __uint128_t uint128_t;
 typedef __int128_t int128_t;
+/** @} */
 #endif
 
 /**
@@ -89,10 +99,13 @@
   {}
   /**
    * \name Construct from a floating point value.
+   */
+  /**
+   * @{
+   * Constructor from a floating point.
    *
    * \param [in] value Floating value to represent.
    */
-  /**@{*/
   inline int64x64_t (const double value)
   {
     const int64x64_t tmp ((long double)value);
@@ -130,10 +143,13 @@
 
   /**
    * \name Construct from an integral type.
+   */
+  /**@{*/
+  /**
+   * Construct from an integral type.
    *
    * \param [in] v Integer value to represent.
    */
-  /**@{*/
   inline int64x64_t (const int v)
     : _v (v)
   {
@@ -164,6 +180,9 @@
   {
     _v <<= 64;
   }
+  inline int64x64_t (const int128_t v)
+    : _v (v)
+  {}
   /**@}*/
 
   /**
@@ -198,6 +217,12 @@
     return *this;
   }
 
+  /** Explicit bool conversion. */
+  inline explicit operator bool () const
+  {
+    return (_v != 0);
+  }
+
   /**
    * Get this value as a double.
    *
@@ -304,15 +329,32 @@
    *  \param [in] rhs Right hand argument
    *  \return The result of the operator.
    */
-  friend bool         operator == (const int64x64_t & lhs, const int64x64_t & rhs);
-
-  friend bool         operator <  (const int64x64_t & lhs, const int64x64_t & rhs);
-  friend bool         operator >  (const int64x64_t & lhs, const int64x64_t & rhs);
-
-  friend int64x64_t & operator += (      int64x64_t & lhs, const int64x64_t & rhs);
-  friend int64x64_t & operator -= (      int64x64_t & lhs, const int64x64_t & rhs);
-  friend int64x64_t & operator *= (      int64x64_t & lhs, const int64x64_t & rhs);
-  friend int64x64_t & operator /= (      int64x64_t & lhs, const int64x64_t & rhs);
+  // *NS_CHECK_STYLE_OFF*
+  friend inline bool operator == (const int64x64_t & lhs, const int64x64_t & rhs) { return lhs._v == rhs._v; };
+  friend inline bool operator <  (const int64x64_t & lhs, const int64x64_t & rhs) { return lhs._v < rhs._v; };
+  friend inline bool operator >  (const int64x64_t & lhs, const int64x64_t & rhs) { return lhs._v > rhs._v; };
+
+  friend inline int64x64_t & operator += (int64x64_t & lhs, const int64x64_t & rhs)
+    {
+      lhs._v += rhs._v;
+       return lhs;
+    };
+  friend inline int64x64_t & operator -= (int64x64_t & lhs, const int64x64_t & rhs)
+    {
+      lhs._v -= rhs._v;
+      return lhs;
+    };
+  friend inline int64x64_t & operator *= (int64x64_t & lhs, const int64x64_t & rhs)
+    {
+      lhs.Mul (rhs);
+      return lhs;
+    };
+  friend inline int64x64_t & operator /= (int64x64_t & lhs, const int64x64_t & rhs)
+    {
+      lhs.Div (rhs);
+      return lhs;
+    };
+  // *NS_CHECK_STYLE_ON*
   /**@}*/
 
   /**
@@ -325,8 +367,9 @@
    *  \param [in] lhs Left hand argument
    *  \return The result of the operator.
    */
-  friend int64x64_t   operator -  (const int64x64_t & lhs);
-  friend int64x64_t   operator !  (const int64x64_t & lhs);
+  friend inline int64x64_t   operator +  (const int64x64_t & lhs) { return lhs; };
+  friend inline int64x64_t   operator -  (const int64x64_t & lhs) { return int64x64_t (-lhs._v); };
+  friend inline int64x64_t   operator !  (const int64x64_t & lhs) { return int64x64_t (!lhs._v); };
   /**@}*/
 
   /**
@@ -385,134 +428,11 @@
    */
   static uint128_t UmulByInvert (const uint128_t a, const uint128_t b);
 
-  /**
-   * Construct from an integral type.
-   *
-   * \param [in] v Integer value to represent.
-   */
-  inline int64x64_t (const int128_t v)
-    : _v (v)
-  {}
-
   int128_t _v;  //!< The Q64.64 value.
 
 };  // class int64x64_t
 
 
-/**
- * \ingroup highprec
- * Equality operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline bool operator == (const int64x64_t & lhs, const int64x64_t & rhs)
-{
-  return lhs._v == rhs._v;
-}
-/**
- * \ingroup highprec
- * Less than operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline bool operator < (const int64x64_t & lhs, const int64x64_t & rhs)
-{
-  return lhs._v < rhs._v;
-}
-/**
- * \ingroup highprec
- * Greater operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline bool operator > (const int64x64_t & lhs, const int64x64_t & rhs)
-{
-  return lhs._v > rhs._v;
-}
-
-/**
- * \ingroup highprec
- * Compound addition operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline int64x64_t & operator += (int64x64_t & lhs, const int64x64_t & rhs)
-{
-  lhs._v += rhs._v;
-  return lhs;
-}
-/**
- * \ingroup highprec
- * Compound subtraction operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline int64x64_t & operator -= (int64x64_t & lhs, const int64x64_t & rhs)
-{
-  lhs._v -= rhs._v;
-  return lhs;
-}
-/**
- * \ingroup highprec
- * Compound multiplication operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline int64x64_t & operator *= (int64x64_t & lhs, const int64x64_t & rhs)
-{
-  lhs.Mul (rhs);
-  return lhs;
-}
-/**
- * \ingroup highprec
- * Compound division operator.
- * \param [in] lhs Left hand argument
- * \param [in] rhs Right hand argument
- * \return The result of the operator.
- */
-inline int64x64_t & operator /= (int64x64_t & lhs, const int64x64_t & rhs)
-{
-  lhs.Div (rhs);
-  return lhs;
-}
-
-/**
- * \ingroup highprec
- * Unary plus operator.
- * \param [in] lhs Left hand argument
- * \return The result of the operator.
- */
-inline int64x64_t operator + (const int64x64_t & lhs)
-{
-  return lhs;
-}
-/**
- * \ingroup highprec
- * Unary negation operator (change sign operator).
- * \param [in] lhs Left hand argument
- * \return The result of the operator.
- */
-inline int64x64_t operator - (const int64x64_t & lhs)
-{
-  return int64x64_t (-lhs._v);
-}
-/**
- * \ingroup highprec
- * Logical not operator.
- * \param [in] lhs Left hand argument
- * \return The result of the operator.
- */
-inline int64x64_t operator ! (const int64x64_t & lhs)
-{
-  return int64x64_t (!lhs._v);
-}
-
 
 } // namespace ns3
 
